/* Copyright (c) 2016, Jan Wiśniewski <vuko@hackerspace.pl>
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 */

#ifndef MFIFO_H
#define MFIFO_H

#include<stdint.h>
#include<stdio.h>

typedef struct fifo {
    uint16_t first;
    uint16_t last;
    uint8_t *data;
    uint16_t size;
} fifo;

void fifoInit(fifo*,uint8_t*,uint16_t);
inline uint8_t fifoEmpty(fifo*);
inline uint8_t fifoFull(fifo*);
void fifoPush(fifo*,uint8_t);
uint8_t fifoPop(fifo*);
#endif
