/* Copyright (c) 2016, vuko@hackerspace.pl 
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 */
#include"iobuffers.h"
#include <libopencm3/cm3/nvic.h>
#include<libopencmsis/core_cm3.h>
#include <libopencm3/stm32/usart.h>
#include <libopencm3/usb/usbd.h>

#include "usb.h"

int _write(int file, char *ptr, int len){
    (void)file;
    int no = 0;
    __disable_irq();
        while(no<len && !fifoFull(&tx_fifo)){
            fifoPush(&tx_fifo, ptr[no]);
            ++no;
        }
#ifdef STDIO_UART
	USART_CR1(USART1) |= USART_CR1_TXEIE;
    __enable_irq();
#endif
#ifdef STDIO_USB
    if(usb_tx_in_progress == 0){
        usb_tx_in_progress = 1;
        __enable_irq();
        cdcacm_data_tx_cb(usbd_dev,0x82);
    }
    else    
        __enable_irq();
#endif
    return no;
}

int _write_block(int file, char *ptr, int len){
    (void)file;
    int no = 0;
    __disable_irq();
    while(no<len){
        while(fifoFull(&tx_fifo)){
            __WFI();
            __enable_irq();
            __asm("nop"); // TODO remove
            __disable_irq();
        }
       fifoPush(&tx_fifo, ptr[no]);
       ++no;
    }
#ifdef STDIO_UART
	USART_CR1(USART1) |= USART_CR1_TXEIE;
    __enable_irq();
    return no;
#endif
#ifdef STDIO_USB
    if(usb_tx_in_progress == 0){
        usb_tx_in_progress = 1;
        __enable_irq();
        cdcacm_data_tx_cb(usbd_dev,0x82);
    }
    else    
        __enable_irq();
    return no;
#endif
}

int _read(int file, char *ptr, int len){
    (void)file;
    int no = 0;
    __disable_irq();
        while(no<len && !fifoEmpty(&rx_fifo)){
            ptr[no] = fifoPop(&rx_fifo);
            ++no;
        }
    __enable_irq();
    return no;
}

int _read_block(int file, char *ptr, int len){
    (void)file;
    int no = 0;
    __disable_irq();
    while(no<len){
        while(fifoEmpty(&rx_fifo)){
            __WFI();
            __enable_irq();
            __asm("nop");
            __disable_irq();
        }
        ptr[no] = fifoPop(&rx_fifo);
        ++no;
    }
    __enable_irq();
    return no;
}
